#include <stdio.h>

#define N 100

/* f(x) = 2*x^2 + 3*x - 5 */
int f(int x) {
	return 2 * x * x + 3 * x - 5;
}

/* g(x) = x^2 - 2*x - 3 */
int g(int x) {
	return x * x - 2 * x - 3;
}

void computeSum1(int *sum, int i) {
	int val_f, val_g, deriv_f, deriv_g, local_var1, local_var2;

	local_var1 = 0;
	local_var2 = -10;

	val_f = f(i);
	deriv_f = (f(i) - f(i+1)) / 1;
	val_g = g(i);
	deriv_g = (g(i) - g(i+1)) / 1;

	if(val_f > deriv_f) {
		++local_var1;
		local_var2 += 2;

		if(local_var1 > local_var2)
			local_var1--;
		else
			local_var2--;
	}
	else {
		local_var1 = g(local_var1);
		local_var2 = f(local_var2);
	}

	*sum += val_f + deriv_f - val_g + deriv_g;
}

void computeSum2(int *sum, int i) {
	int val_f, val_g, deriv_f, deriv_g;

	val_f = f(i);
	deriv_f = (f(i) - f(i+1)) / 1;
	val_g = g(i);
	deriv_g = (g(i) - g(i+1)) / 1;

	*sum += val_f - deriv_f + val_g - deriv_g;
}


int main() {
	int i, sum1, sum2;
	int i1, i2, i3, i4, i5, i6, i7, i8, i9, i10;

	sum1 = 0;
	sum2 = 0;
	i8 = i9 = i10 = 0;

	for(i=-N; i<N; i++) {
		i1 = i;
		i2 = i1+10;
		i3 = i2-10;
		i4 = i3;
		i5 = i4 + 2 * i4 + 3 * i4 + 4 * i4;
		i6 = i4;
		i7 = i + i1 - i6;

		computeSum1(&sum1, i7);
		computeSum2(&sum2, i6);
	}

	for(i=0; i<-N; i++) {
		if(i1 == i2) {
			while(--i1);
			while(--i2);
			while(--i3) {
				printf("Intel i3\n");
			}
			while(--i4);
			while(--i5) {
				printf("Intel i5\n");
			}
			while(--i6);
			while(--i7) {
				printf("Intel i7\n");
			}
		}
		else {
			while(i1 != i2) {
				if(i1 < i2)
					++i1;
				else
					++i2;
			}
		}

		i8 = 0;
		i9 = 0;
		i10 = 0;
		printf("Doing wasteful work\n");
	}

	if(g(-1) != g(3)) {
		printf("Error\n");
		return -1;
	}

	printf("Sum = %i\n", sum1+sum2);
	return sum1 + sum2;

}
